// Code generated by go-swagger; DO NOT EDIT.

package workflow_services

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewListWorkflowServiceRevisionPodsParams creates a new ListWorkflowServiceRevisionPodsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewListWorkflowServiceRevisionPodsParams() *ListWorkflowServiceRevisionPodsParams {
	return &ListWorkflowServiceRevisionPodsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewListWorkflowServiceRevisionPodsParamsWithTimeout creates a new ListWorkflowServiceRevisionPodsParams object
// with the ability to set a timeout on a request.
func NewListWorkflowServiceRevisionPodsParamsWithTimeout(timeout time.Duration) *ListWorkflowServiceRevisionPodsParams {
	return &ListWorkflowServiceRevisionPodsParams{
		timeout: timeout,
	}
}

// NewListWorkflowServiceRevisionPodsParamsWithContext creates a new ListWorkflowServiceRevisionPodsParams object
// with the ability to set a context for a request.
func NewListWorkflowServiceRevisionPodsParamsWithContext(ctx context.Context) *ListWorkflowServiceRevisionPodsParams {
	return &ListWorkflowServiceRevisionPodsParams{
		Context: ctx,
	}
}

// NewListWorkflowServiceRevisionPodsParamsWithHTTPClient creates a new ListWorkflowServiceRevisionPodsParams object
// with the ability to set a custom HTTPClient for a request.
func NewListWorkflowServiceRevisionPodsParamsWithHTTPClient(client *http.Client) *ListWorkflowServiceRevisionPodsParams {
	return &ListWorkflowServiceRevisionPodsParams{
		HTTPClient: client,
	}
}

/* ListWorkflowServiceRevisionPodsParams contains all the parameters to send to the API endpoint
   for the list workflow service revision pods operation.

   Typically these are written to a http.Request.
*/
type ListWorkflowServiceRevisionPodsParams struct {

	/* Namespace.

	   target namespace
	*/
	Namespace string

	/* Rev.

	   target service revison
	*/
	Rev string

	/* Svn.

	   target service name
	*/
	Svn string

	/* Workflow.

	   path to target workflow
	*/
	Workflow string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the list workflow service revision pods params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ListWorkflowServiceRevisionPodsParams) WithDefaults() *ListWorkflowServiceRevisionPodsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the list workflow service revision pods params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ListWorkflowServiceRevisionPodsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the list workflow service revision pods params
func (o *ListWorkflowServiceRevisionPodsParams) WithTimeout(timeout time.Duration) *ListWorkflowServiceRevisionPodsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the list workflow service revision pods params
func (o *ListWorkflowServiceRevisionPodsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the list workflow service revision pods params
func (o *ListWorkflowServiceRevisionPodsParams) WithContext(ctx context.Context) *ListWorkflowServiceRevisionPodsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the list workflow service revision pods params
func (o *ListWorkflowServiceRevisionPodsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the list workflow service revision pods params
func (o *ListWorkflowServiceRevisionPodsParams) WithHTTPClient(client *http.Client) *ListWorkflowServiceRevisionPodsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the list workflow service revision pods params
func (o *ListWorkflowServiceRevisionPodsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithNamespace adds the namespace to the list workflow service revision pods params
func (o *ListWorkflowServiceRevisionPodsParams) WithNamespace(namespace string) *ListWorkflowServiceRevisionPodsParams {
	o.SetNamespace(namespace)
	return o
}

// SetNamespace adds the namespace to the list workflow service revision pods params
func (o *ListWorkflowServiceRevisionPodsParams) SetNamespace(namespace string) {
	o.Namespace = namespace
}

// WithRev adds the rev to the list workflow service revision pods params
func (o *ListWorkflowServiceRevisionPodsParams) WithRev(rev string) *ListWorkflowServiceRevisionPodsParams {
	o.SetRev(rev)
	return o
}

// SetRev adds the rev to the list workflow service revision pods params
func (o *ListWorkflowServiceRevisionPodsParams) SetRev(rev string) {
	o.Rev = rev
}

// WithSvn adds the svn to the list workflow service revision pods params
func (o *ListWorkflowServiceRevisionPodsParams) WithSvn(svn string) *ListWorkflowServiceRevisionPodsParams {
	o.SetSvn(svn)
	return o
}

// SetSvn adds the svn to the list workflow service revision pods params
func (o *ListWorkflowServiceRevisionPodsParams) SetSvn(svn string) {
	o.Svn = svn
}

// WithWorkflow adds the workflow to the list workflow service revision pods params
func (o *ListWorkflowServiceRevisionPodsParams) WithWorkflow(workflow string) *ListWorkflowServiceRevisionPodsParams {
	o.SetWorkflow(workflow)
	return o
}

// SetWorkflow adds the workflow to the list workflow service revision pods params
func (o *ListWorkflowServiceRevisionPodsParams) SetWorkflow(workflow string) {
	o.Workflow = workflow
}

// WriteToRequest writes these params to a swagger request
func (o *ListWorkflowServiceRevisionPodsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param namespace
	if err := r.SetPathParam("namespace", o.Namespace); err != nil {
		return err
	}

	// query param rev
	qrRev := o.Rev
	qRev := qrRev
	if qRev != "" {

		if err := r.SetQueryParam("rev", qRev); err != nil {
			return err
		}
	}

	// query param svn
	qrSvn := o.Svn
	qSvn := qrSvn
	if qSvn != "" {

		if err := r.SetQueryParam("svn", qSvn); err != nil {
			return err
		}
	}

	// path param workflow
	if err := r.SetPathParam("workflow", o.Workflow); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
